searchNodes=[{"ref":"MMDB2Decoder.html","title":"MMDB2Decoder","type":"module","doc":"MMDB2 file format decoder. Usage To prepare lookups in a given database you need to parse it and hold the result available for later usage: iex(1)&gt; database = File.read!(&quot;/path/to/database.mmdb&quot;) iex(2)&gt; {:ok, meta, tree, data} = MMDB2Decoder.parse_database(database) Using the returned database contents you can start looking up individual entries: iex(3)&gt; {:ok, ip} = :inet.parse(String.to_charlist(&quot;127.0.0.1&quot;)) iex(4)&gt; MMDB2Decoder.lookup(ip, meta, tree, data) {:ok, %{...}} For more details on the lookup methods (and a function suitable for direct piping) please see the individual function documentations. Lookup Options The behaviour of the decoder can be adjusted by passing an option map as the last argument to the lookup functions: iex&gt; MMDB2Decoder.lookup(ip, meta, tree, data, %{map_keys: :atoms!}) The following options are available: :map_keys defines the type of the keys in a decoded map: :strings is the default value :atoms uses String.to_atom/1 :atoms! uses String.to_existing_atom/1 :double_precision defines the precision of decoded Double values nil is the default for &quot;unlimited&quot; precision any value from Float.precision_range/0 to round the precision to :float_precision defines the precision of decoded Float values nil is the default for &quot;unlimited&quot; precision any value from Float.precision_range/0 to round the precision to"},{"ref":"MMDB2Decoder.html#find_pointer/3","title":"MMDB2Decoder.find_pointer/3","type":"function","doc":"Fetches the pointer of an IP in the data if available. The pointer will be calculated to be relative to the start of the binary data. Usage iex&gt; MMDB2Decoder.find_pointer({127, 0, 0, 1}, meta, tree) 123456"},{"ref":"MMDB2Decoder.html#find_pointer!/3","title":"MMDB2Decoder.find_pointer!/3","type":"function","doc":"Calls find_pointer/3 and raises if an error occurs."},{"ref":"MMDB2Decoder.html#lookup/5","title":"MMDB2Decoder.lookup/5","type":"function","doc":"Looks up the data associated with an IP tuple. This is probably the main function you will use. The ip address is expected to be a 4- or 8-element tuple describing an IPv4 or IPv6 address. To obtain this tuple from a string you can use :inet.ip_address/1. Usage iex&gt; MMDB2Decoder.lookup({127, 0, 0, 1}, meta, tree, data) { :ok, %{ &quot;continent&quot; =&gt; %{...}, &quot;country&quot; =&gt; %{...}, &quot;registered_country&quot; =&gt; %{...} } } The values for meta, tree and data can be obtained by parsing the file contents of a database using parse_database/1."},{"ref":"MMDB2Decoder.html#lookup!/5","title":"MMDB2Decoder.lookup!/5","type":"function","doc":"Calls lookup/4 and raises if an error occurs."},{"ref":"MMDB2Decoder.html#lookup_pointer/3","title":"MMDB2Decoder.lookup_pointer/3","type":"function","doc":"Fetches the data at a given pointer position. The pointer is expected to be relative to the start of the binary data. Usage iex&gt; MMDB2Decoder.lookup_pointer(123456, data) { :ok, %{ &quot;continent&quot; =&gt; %{...}, &quot;country&quot; =&gt; %{...}, &quot;registered_country&quot; =&gt; %{...} } }"},{"ref":"MMDB2Decoder.html#lookup_pointer!/3","title":"MMDB2Decoder.lookup_pointer!/3","type":"function","doc":"Calls lookup_pointer/3 and unrolls the return tuple."},{"ref":"MMDB2Decoder.html#parse_database/1","title":"MMDB2Decoder.parse_database/1","type":"function","doc":"Parses a database binary and splits it into metadata, lookup tree and data. It is expected that you pass the real contents of the file, not the name of the database or the path to it. Usage iex&gt; MMDB2Decoder.parse_database(File.read!(&quot;/path/to/database.mmdb&quot;)) { :ok, %MMDB2Decoder.Metadata{...}, &lt;&lt;...&gt;&gt;, &lt;&lt;...&gt;&gt; } If parsing the database fails you will receive an appropriate error tuple: iex&gt; MMDB2Decoder.parse_database(&quot;invalid-database-contents&quot;) {:error, :no_metadata}"},{"ref":"MMDB2Decoder.html#pipe_lookup/3","title":"MMDB2Decoder.pipe_lookup/3","type":"function","doc":"Utility method to pipe parse_database/1 directly to lookup/4. Usage Depending on how you handle the parsed database contents you may want to pass the results directly to the lookup. iex&gt; &quot;/path/to/database.mmdb&quot; ...&gt; |&gt; File.read!() ...&gt; |&gt; MMDB2Decoder.parse_database() ...&gt; |&gt; MMDB2Decoder.pipe_lookup({127, 0, 0, 1}) {:ok, %{...}}"},{"ref":"MMDB2Decoder.html#pipe_lookup!/3","title":"MMDB2Decoder.pipe_lookup!/3","type":"function","doc":"Calls pipe_lookup/2 and raises if an error from parse_database/1 is given or occurs during lookup/4."},{"ref":"MMDB2Decoder.html#t:decode_option/0","title":"MMDB2Decoder.decode_option/0","type":"type","doc":""},{"ref":"MMDB2Decoder.html#t:decode_options/0","title":"MMDB2Decoder.decode_options/0","type":"type","doc":""},{"ref":"MMDB2Decoder.html#t:decode_options_map/0","title":"MMDB2Decoder.decode_options_map/0","type":"type","doc":""},{"ref":"MMDB2Decoder.html#t:decoded_value/0","title":"MMDB2Decoder.decoded_value/0","type":"type","doc":""},{"ref":"MMDB2Decoder.html#t:lookup_result/0","title":"MMDB2Decoder.lookup_result/0","type":"type","doc":""},{"ref":"MMDB2Decoder.html#t:lookup_value/0","title":"MMDB2Decoder.lookup_value/0","type":"type","doc":""},{"ref":"MMDB2Decoder.html#t:parse_result/0","title":"MMDB2Decoder.parse_result/0","type":"type","doc":""},{"ref":"MMDB2Decoder.html#t:tree_result/0","title":"MMDB2Decoder.tree_result/0","type":"type","doc":""},{"ref":"MMDB2Decoder.Metadata.html","title":"MMDB2Decoder.Metadata","type":"module","doc":"Metadata struct."},{"ref":"MMDB2Decoder.Metadata.html#t:t/0","title":"MMDB2Decoder.Metadata.t/0","type":"type","doc":""}]